﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.UI.Scheduler.Dialogs;

namespace SchedulerCustomAppointmentDB
{
    public partial class CustomAppointmentEditForm : EditAppointmentDialog
    {
        Form1 mainForm;

        public CustomAppointmentEditForm()
        {
            InitializeComponent();
        }
          public CustomAppointmentEditForm(Form1 mainForm)
        {
            InitializeComponent();
            this.mainForm = mainForm;
        }

        public CustomAppointmentEditForm(IEvent appointment, ISchedulerData schedulerData):base( appointment,  schedulerData)
        {
            InitializeComponent();
            this.mainForm = mainForm;
        }

        protected override void LoadSettingsFromEvent(IEvent ev)
        {
            base.LoadSettingsFromEvent(ev);

            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                this.txtEmail.Text = appointmentWithEmail.Email;
            }
        }

        protected override void ApplySettingsToEvent(IEvent ev)
        {
            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                appointmentWithEmail.Email = this.txtEmail.Text;
            }
            base.ApplySettingsToEvent(ev);
        }

        protected override IEvent CreateNewEvent()
        {
            return new AppointmentWithEmail();
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            base.OnClosing(e);
            if (this.DialogResult == System.Windows.Forms.DialogResult.OK && mainForm != null)
            {
                mainForm.SaveScheduler();
            }
        }
    }
}
